//
// Created by centos on 24. 3. 15..
//

#include "Poco/Process.h"
#include "Poco/PipeStream.h"
#include "Poco/StreamCopier.h"
#include "Poco/SharedMemory.h"
#include <fstream>
#include <iostream>
#include <cstring>

int main(int argc, char** argv){
    std::cout<<"PID: "<<Poco::Process::id()<<std::endl;
    if(argc==2){
        std::cout<<"process call worked."<<std::endl;
        Poco::SharedMemory mem2("MySharedMemory", 64,static_cast<Poco::SharedMemory::AccessMode>(Poco::SharedMemory::AM_READ |Poco::SharedMemory::AM_WRITE));
        std::cout<<mem2.begin();

        return 0;
    }


    //shared memory test
//    Poco::SharedMemory mem1("MySharedMemory", 1024,Poco::SharedMemory::AM_READ | Poco::SharedMemory::AM_WRITE);
    Poco::SharedMemory mem2("MySharedMemory", 64,static_cast<Poco::SharedMemory::AccessMode>(Poco::SharedMemory::AM_READ |Poco::SharedMemory::AM_WRITE));
    for (char* ptr = mem2.begin(); ptr != mem2.end(); ++ptr)
    {
        *ptr = 0;
    }
    std::string txt="hello world in shared memory.\n";
    char* ptr1 =mem2.begin();
    strcpy(ptr1,txt.c_str());



    //process 를 실행시켜 출력 스트림을 pipe를 통해 processes_test.txt 에 저장.
    Poco::Pipe outPipe;
    std::vector<std::string> arg;
    arg.emplace_back("1");
    Poco::ProcessHandle ph = Poco::Process::launch("./process_test",arg,0,&outPipe,0);
    Poco::PipeInputStream istr(outPipe);
    std::ofstream ostr("processes_test.txt");
    Poco::StreamCopier::copyStream(istr, ostr);

    std::cout<<"write on \"processes_test.txt\".\ncheck file."<<std::endl;

    return 0;

}